/*
 * modules_list.js
 */
////////////////////////////////////////////////////////////////////////////////
 /** Modules that need to be initialized and register their page handlers
 * in the beginning.
 * Each should implement an init() method, which will be called only once.
 * Register your page handlers in it.
 */
Foxtrick.modules = [ FoxtrickForumChangePosts,
					 FoxtrickShowForumPrefButton,
					 FoxtrickMovePlayerSelectbox,  // keep before others on playerdetails page
					 FoxtrickAddManagerButtons,   // keep before FoxtrickAddDefaultFaceCard
                     FoxtrickMovePlayerStatement,
                     FoxtrickFixcssProblems,
                     FoxtrickForumTemplates,
                     FoxtrickForumPreview,
                     FoxtrickForumYouthIcons,
					 BookmarkAdjust,
                     FoxtrickHideManagerAvatar,
                     FoxtrickAddDefaultFaceCard,
                     FoxtrickMoveLinks,   // keep before FoxtrickHideManagerAvatarUserInfo
                     FoxtrickAlltidFlags,  // keep before FoxtrickHideManagerAvatarUserInfo
					 FoxtrickForumAlterHeaderLine,
                     FoxtrickTeamPopupLinks,
					 FoxtrickTeamPopupLinksMore,
					 FoxtrickHideManagerAvatarUserInfo,
                     FoxtrickGoToPostBox,
					 FoxtrickContextMenueCopyId,					 
                     FoxtrickCopyPostID, 
					 FoxtrickForumStaffMarker,
                     FoxtrickHTThreadMarker,
                     FoxtrickMedianTransferPrice,
                     FoxtrickYouthSkillNotes,
                     FoxtrickAddLeaveConfButton,
                     FoxtrickFlipSidesInMatchOrders,
                     FoxtrickStarsCounter,
                     FoxtrickRepositionedPlayers,
                     FoxtrickAdvancedStarsCounter,
                     FoxtrickFormationBoxInMatchOrders,
                     FoxtrickFlagCollectionToMap,
                     FoxtrickTransferListSearchFilters,
                     FoxtrickTransferListDeadline,
                     FoxtrickExtendedPlayerDetails,
                     FoxtrickHTDateFormat,
                     FoxtrickMatchPlayerColouring,
                     AttVsDef, // AttVsDef should be placed before Ratings
					 Ratings,
                     FTTeamStats,  // before FoxtrickLinksPlayers
					 FoxtrickAlert,
                     FoxtrickHideFaceTransferImages,
                     FoxtrickHideFaceInjuryImages,
                     FoxtrickHideFaceSuspendedImages,
                     FoxtrickColouredYouthFaces,
					 FoxtrickPlayerAdToClipboard,
                     FoxtrickCopyRatingsToClipboard,
					 FoxtrickLinksCustom,
                     FoxtrickLinksLeague,
                     FoxtrickLinksCountry,
                     FoxtrickLinksTeam,
                     FoxtrickLinksChallenges,
                     FoxtrickLinksEconomy,
                     FoxtrickLinksYouthOverview,
                     FoxtrickLinksArena,
                     FoxtrickLinksCoach,
                     FoxtrickLinksPlayerDetail,
                     FoxtrickLinksMatch,
                     FoxtrickLinksTraining,
					 FoxtrickLinksAlliances,
					 FoxtrickLinksNational,
                     FoxtrickLinksManager,
					 FoxtrickLinksAchievements,
                     FoxtrickLinksPlayers,
                     FoxtrickLinksFans,
                     FoxtrickLinksStaff,
					 FoxtrickLinksTracker,
                     FoxtrickConfirmPlayerBid,
					 FoxtrickConfirmTL,
                     FoxtrickEconomyDifference,
                     FoxtrickHideSignatures,
                     FoxtrickForumNextAndPrevious,
                     FoxtrickPersonalityImages,
                     FoxtrickSkillColoring,
                     FoxtrickSkinPlugin,
                     FoxtrickMatchIncome,                   
					 FoxtrickHelper,
					 FoxtrickLargeFlags,
					 FoxtrickTeamSelectBox,
					 FoxtrickSeniorTeamShortCuts,
                     FoxtrickShortcutsStatistics,
					 FoxtrickCustomMedals,
					 FoxtrickForumRedirManagerToTeam,
					 FoxtrickRedirections,
                     FoxtrickGuestbookAlltidFlags,
                     FoxtrickCurrencyConverter,  
                     FoxtrickTickerColoring,
					 FoxtrickSeasonStats,   // keep before FoxtrickCopyMatchID
					 FoxtrickCopyMatchID,
                     // FoxtrickMatchDayTables //just added, no functions so far
					 FoxtrickHeaderFix,
                     FoxtrickHeaderFixLeft,
                     FoxtrickNewMail,
					 FoxtrickNTConfirmAddRemove,
					 FoxtrickCopyTrainingReport,
					 FoxtrickPlayerBirthday,
					 FoxtrickAddHtLiveToOngoing,					 
					 FoxtrickReadHtPrefs,
					 FoxtrickMyHT,
					 FoxtrickLeagueNewsFilter,
					 FoxtrickShortPAs,
					 FoxtrickCopyPosting,
					 FoxtrickMoveManagerOnline
					];
